Index: issm/trunk/src/c/modules/ModelProcessorx/Transient/UpdateElementsTransient.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Transient/UpdateElementsTransient.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ModelProcessorx/Transient/UpdateElementsTransient.cpp	(revision 13395)
@@ -8,5 +8,5 @@
 #include "../../../modules/modules.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
-#include "../../../objects/objects.h"
+#include "../../../classes/objects/objects.h"
 #include "../../../shared/shared.h"
 #include "../../MeshPartitionx/MeshPartitionx.h"
@@ -15,6 +15,3 @@
 
 void	UpdateElementsTransient(Elements* elements, Parameters* parameters,IoModel* iomodel,int analysis_counter,int analysis_type){
-
-	/*nothing for now: */
-
 }
Index: issm/trunk/src/c/modules/ModelProcessorx/UpdateCounters.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/UpdateCounters.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ModelProcessorx/UpdateCounters.cpp	(revision 13395)
@@ -9,5 +9,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../shared/shared.h"
 #include "../../include/include.h"
Index: issm/trunk/src/c/modules/NodalValuex/NodalValuex.cpp
===================================================================
--- issm/trunk/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 13395)
@@ -38,5 +38,5 @@
 	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
-	if(!sumfound)_error2_("could not find element with vertex with id" << index << " to compute nodal value " << EnumToStringx(natureofdataenum));
+	if(!sumfound)_error_("could not find element with vertex with id" << index << " to compute nodal value " << EnumToStringx(natureofdataenum));
 	#endif
 
Index: issm/trunk/src/c/modules/NodalValuex/NodalValuex.h
===================================================================
--- issm/trunk/src/c/modules/NodalValuex/NodalValuex.h	(revision 12709)
+++ issm/trunk/src/c/modules/NodalValuex/NodalValuex.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/NodeConnectivityx/NodeConnectivityx.cpp
===================================================================
--- issm/trunk/src/c/modules/NodeConnectivityx/NodeConnectivityx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/NodeConnectivityx/NodeConnectivityx.cpp	(revision 13395)
@@ -71,5 +71,5 @@
 	 * warn the user to increase the connectivity width: */
 	for(i=0;i<nods;i++){
-		if (*(connectivity+width*i+maxels)>maxels)_error2_("max connectivity width reached (" << *(connectivity+width*i+maxels) << ")! increase width of connectivity table");
+		if (*(connectivity+width*i+maxels)>maxels)_error_("max connectivity width reached (" << *(connectivity+width*i+maxels) << ")! increase width of connectivity table");
 	}
 
Index: issm/trunk/src/c/modules/NodesDofx/NodesDofx.h
===================================================================
--- issm/trunk/src/c/modules/NodesDofx/NodesDofx.h	(revision 12709)
+++ issm/trunk/src/c/modules/NodesDofx/NodesDofx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Orthx/Orthx.cpp
===================================================================
--- issm/trunk/src/c/modules/Orthx/Orthx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Orthx/Orthx.cpp	(revision 13395)
@@ -5,11 +5,11 @@
 #include "./Orthx.h"
 
-void	Orthx( Vector** pnewgradj, Vector* gradj, Vector* oldgradj){
+void	Orthx( Vector<IssmDouble>** pnewgradj, Vector<IssmDouble>* gradj, Vector<IssmDouble>* oldgradj){
 	
 	/*output: */
-	Vector* newgradj=NULL;
+	Vector<IssmDouble>* newgradj=NULL;
 
 	/*intermediary:*/
-	double norm_new,norm_old,dot_product;;
+	IssmDouble norm_new,norm_old,dot_product;;
 
 	/*Initialize output*/
Index: issm/trunk/src/c/modules/Orthx/Orthx.h
===================================================================
--- issm/trunk/src/c/modules/Orthx/Orthx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Orthx/Orthx.h	(revision 13395)
@@ -6,10 +6,10 @@
 #define _ORTHX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../include/include.h"
 #include "../../shared/shared.h"
 
 /* local prototypes: */
-void	Orthx( Vector** pnewgradj, Vector* gradj, Vector* oldgradj);
+void	Orthx( Vector<IssmDouble>** pnewgradj, Vector<IssmDouble>* gradj, Vector<IssmDouble>* oldgradj);
 
 #endif  /* _ORTHX_H */
Index: issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp
===================================================================
--- issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 13395)
@@ -14,5 +14,5 @@
 #include "../../Container/Container.h"
 #include "../../io/io.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 		
 void OutputResultsx(Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Results* results){
@@ -45,5 +45,5 @@
 		parameters->FindParam(&solutiontype,SolutionTypeEnum);
 		EnumToStringx(&solutiontypestring,solutiontype);
-		results->AddObject(new StringExternalResult(results->Size()+1,SolutionTypeEnum,solutiontypestring,1,0));
+		results->AddObject(new GenericExternalResult<char*>(results->Size()+1,SolutionTypeEnum,solutiontypestring,1,0));
 		xDelete<char>(solutiontypestring);
 	}
Index: issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp
===================================================================
--- issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 13395)
@@ -106,5 +106,5 @@
 		char* string=strings[i];
 		if(my_rank==0){
-			if(string==NULL) _error2_("PETSc options for analysis " << EnumToStringx(reCast<int>(analyses[i])) << " have been declared but were not found");
+			if(string==NULL) _error_("PETSc options for analysis " << EnumToStringx(reCast<int>(analyses[i])) << " have been declared but were not found");
 		}
 		if(my_rank==0)stringlength=(strlen(string)+1)*sizeof(char);
Index: issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.h
===================================================================
--- issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.cpp
===================================================================
--- issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.cpp	(revision 13395)
@@ -4,9 +4,9 @@
 #include "./PointCloudFindNeighborsx.h"
 
-int PointCloudFindNeighborsx( Vector** pflags,double* x, double* y, int nods, double mindistance,double multithread){
+int PointCloudFindNeighborsx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, double mindistance,double multithread){
 
 	/*output: */
-	Vector* flags=NULL;
-	flags=new Vector(nods);
+	SeqVec<IssmPDouble>* flags=NULL;
+	flags=new SeqVec<IssmPDouble>(nods);
 
 	/*threading: */
Index: issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h
===================================================================
--- issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h	(revision 13395)
@@ -8,8 +8,8 @@
 
 #include "../../shared/shared.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-int PointCloudFindNeighborsx( Vector** pflags,double* x, double* y, int nods, double mindistance,double multithread);
+int PointCloudFindNeighborsx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, double mindistance,double multithread);
 
 /*threading: */
@@ -20,6 +20,5 @@
 	int nods;
 	double mindistance;
-	Vector* flags;
-
+	SeqVec<IssmPDouble>* flags;
 
 } PointCloudFindNeighborsThreadStruct;
Index: issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsxt.cpp
===================================================================
--- issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsxt.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsxt.cpp	(revision 13395)
@@ -17,5 +17,5 @@
 	int     nods;
 	double  mindistance;
-	Vector*     flags;
+	SeqVec<IssmPDouble>*     flags;
 
 	/*recover handle and gate: */
Index: issm/trunk/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.h
===================================================================
--- issm/trunk/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.h	(revision 12709)
+++ issm/trunk/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.cpp
===================================================================
--- issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.cpp	(revision 13395)
@@ -12,9 +12,9 @@
 #include "../../io/io.h"
 
-void	Reduceloadx( Vector* pf, Matrix* Kfs, Vector* y_s,bool flag_ys0){
+void	Reduceloadx( Vector<IssmDouble>* pf, Matrix<IssmDouble>* Kfs, Vector<IssmDouble>* y_s,bool flag_ys0){
 
 	/*intermediary*/
-	Vector*     y_s0   = NULL;
-	Vector*     Kfsy_s = NULL;
+	Vector<IssmDouble>*     y_s0   = NULL;
+	Vector<IssmDouble>*     Kfsy_s = NULL;
 	int         Kfsm,Kfsn;
 	int         global_m,global_n;
@@ -32,5 +32,5 @@
 		/*pf = pf - Kfs * y_s;*/
 		Kfs->GetLocalSize(&Kfsm,&Kfsn);
-		Kfsy_s=new Vector(Kfsm,fromlocalsize);
+		Kfsy_s=new Vector<IssmDouble>(Kfsm,fromlocalsize);
 		if (flag_ys0){
 
Index: issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.h
===================================================================
--- issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Reduceloadx/Reduceloadx.h	(revision 13395)
@@ -6,8 +6,8 @@
 #define _REDUCELOADX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void	Reduceloadx( Vector* pf, Matrix* Kfs, Vector* ys,bool flag_ys0=false);
+void	Reduceloadx( Vector<IssmDouble>* pf, Matrix<IssmDouble>* Kfs, Vector<IssmDouble>* ys,bool flag_ys0=false);
 
 #endif  /* _REDUCELOADX_H */
Index: issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp
===================================================================
--- issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp	(revision 13395)
@@ -6,8 +6,8 @@
 #include "./Reducevectorgtofx.h"
  
-void Reducevectorgtofx(Vector** puf, Vector* ug, Nodes* nodes,Parameters* parameters){
+void Reducevectorgtofx(Vector<IssmDouble>** puf, Vector<IssmDouble>* ug, Nodes* nodes,Parameters* parameters){
 
 	/*output: */
-	Vector* uf=NULL;
+	Vector<IssmDouble>* uf=NULL;
 
 	/*variables: */
@@ -26,5 +26,5 @@
 	else{
 		/*allocate: */
-		uf=new Vector(fsize);
+		uf=new Vector<IssmDouble>(fsize);
 
 		if(nodes->NumberOfNodes(configuration_type)){ 
Index: issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.h
===================================================================
--- issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.h	(revision 13395)
@@ -7,8 +7,8 @@
 #define _REDUCEVECTORGTOFX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void Reducevectorgtofx(Vector** puf, Vector* ug, Nodes* nodes,Parameters* parameters);
+void Reducevectorgtofx(Vector<IssmDouble>** puf, Vector<IssmDouble>* ug, Nodes* nodes,Parameters* parameters);
 
 #endif  /* _REDUCEVECTORGTOFX_H */
Index: issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp
===================================================================
--- issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp	(revision 13395)
@@ -6,8 +6,8 @@
 #include "./Reducevectorgtosx.h"
 
-void Reducevectorgtosx(Vector** pys, Vector* yg, Nodes* nodes,Parameters* parameters){
+void Reducevectorgtosx(Vector<IssmDouble>** pys, Vector<IssmDouble>* yg, Nodes* nodes,Parameters* parameters){
 
 	/*output: */
-	Vector* ys=NULL;
+	Vector<IssmDouble>* ys=NULL;
 
 	/*variables: */
@@ -15,5 +15,5 @@
 	int configuration_type;
 	int ssize;
-	double* yg_serial=NULL;
+	IssmDouble* yg_serial=NULL;
 
 	/*first figure out ssize: */
@@ -26,5 +26,5 @@
 	else{
 		/*allocate: */
-		ys=new Vector(ssize);
+		ys=new Vector<IssmDouble>(ssize);
 
 		if(nodes->NumberOfNodes(configuration_type)){ 
@@ -51,5 +51,5 @@
 
 	/*Free ressources:*/
-	xDelete<double>(yg_serial);
+	xDelete<IssmDouble>(yg_serial);
 
 	/*Assign output pointers:*/
Index: issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.h
===================================================================
--- issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.h	(revision 13395)
@@ -7,8 +7,8 @@
 #define _REDUCEVECTORGTOSX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void Reducevectorgtosx(Vector** pys, Vector* yg, Nodes* nodes,Parameters* parameters);
+void Reducevectorgtosx(Vector<IssmDouble>** pys, Vector<IssmDouble>* yg, Nodes* nodes,Parameters* parameters);
 
 #endif  /* _REDUCEVECTORGTOSX_H */
Index: issm/trunk/src/c/modules/RequestedDependentsx/RequestedDependentsx.cpp
===================================================================
--- issm/trunk/src/c/modules/RequestedDependentsx/RequestedDependentsx.cpp	(revision 13395)
+++ issm/trunk/src/c/modules/RequestedDependentsx/RequestedDependentsx.cpp	(revision 13395)
@@ -0,0 +1,45 @@
+/*!\file RequestedDependentsx
+ * \brief: compute outputs that were requested specifically for this solution, such as BasalStress, StrainHeating, etc ...
+ */
+
+#include "../../modules/modules.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+void RequestedDependentsx(Results* results,Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters){
+
+
+
+	int         i;
+	int         output_enum;
+	bool        isautodiff      = false;
+	IssmDouble  output_value;
+	Element    *element         = NULL;
+	int        *dependent_enums = NULL;
+
+	int         num_dependents;
+	IssmPDouble *dependents;
+
+	/*AD mode on?: */
+	parameters->FindParam(&isautodiff,AutodiffIsautodiffEnum);
+
+	if(isautodiff){
+		#ifdef _HAVE_ADOLC_
+		parameters->FindParam(&num_dependents,AutodiffNumDependentsEnum);
+		if(num_dependents){
+			dependents=xNew<IssmPDouble>(num_dependents);
+			parameters->FindParam(&dependent_enums,&num_dependents,AutodiffDependentsEnum);
+
+			/*Go through our dependent variables, and compute the response:*/
+			for(i=0;i<num_dependents;i++){
+				Responsex(&output_value,elements,nodes,vertices,loads,materials,parameters,dependent_enums[i],false,0);
+				output_value>>=dependents[i];
+			}
+		}
+		#else
+		_error_("Should not be requesting dependents when an AD library is not available!");
+		#endif
+	}
+}
Index: issm/trunk/src/c/modules/RequestedDependentsx/RequestedDependentsx.h
===================================================================
--- issm/trunk/src/c/modules/RequestedDependentsx/RequestedDependentsx.h	(revision 13395)
+++ issm/trunk/src/c/modules/RequestedDependentsx/RequestedDependentsx.h	(revision 13395)
@@ -0,0 +1,14 @@
+/*!\file:  RequestedDependentsx.h
+ * \brief header file for  requesting AD dependents
+ */ 
+
+#ifndef _REQUESTED_DEPENDENTSX_H_
+#define _REQUESTED_DEPENDENTSX_H_
+
+#include "../../Container/Container.h"
+
+/* local prototypes: */
+void RequestedDependentsx(Results* results,Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters);
+
+#endif  /* _INPUTTORESULTX_H */
+
Index: issm/trunk/src/c/modules/RequestedOutputsx/RequestedOutputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/RequestedOutputsx/RequestedOutputsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/RequestedOutputsx/RequestedOutputsx.cpp	(revision 13395)
@@ -30,5 +30,9 @@
 				case IceVolumeEnum:
 					Responsex(&output_value,elements,nodes,vertices,loads,materials,parameters,"IceVolume",false,0);
-					results->AddObject(new DoubleExternalResult(results->Size()+1,IceVolumeEnum,output_value,step,time));
+					results->AddObject(new GenericExternalResult<double>(results->Size()+1,IceVolumeEnum,reCast<IssmPDouble>(output_value),step,time));
+					break;
+				case TotalSmbEnum:
+					Responsex(&output_value,elements,nodes,vertices,loads,materials,parameters,"TotalSmb",false,0);
+					results->AddObject(new GenericExternalResult<double>(results->Size()+1,TotalSmbEnum,reCast<IssmPDouble>(output_value),step,time));
 					break;
 				default:
Index: issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp	(revision 13395)
@@ -30,5 +30,5 @@
 	 * management routine, otherwise, skip : */
 	if (RiftIsPresent(loads,analysis_type)){
-		_error2_("rift constraints reset not supported yet!");
+		_error_("rift constraints reset not supported yet!");
 	}
 	else if(ThermalIsPresent(loads,analysis_type)){
Index: issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.h
===================================================================
--- issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ResetConstraintsx/ResetConstraintsx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.h
===================================================================
--- issm/trunk/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.h	(revision 12709)
+++ issm/trunk/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Responsex/Responsex.cpp
===================================================================
--- issm/trunk/src/c/modules/Responsex/Responsex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Responsex/Responsex.cpp	(revision 13395)
@@ -14,9 +14,19 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 #include "../../toolkits/toolkits.h"
+#include "./Responsex.h"
 #include "../modules.h"
 
 void Responsex(IssmDouble* responses,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,const char* response_descriptor,bool process_units,int weight_index){
 
-	switch (StringToEnumx(response_descriptor)){
+	int response_descriptor_enum;
+
+	response_descriptor_enum=StringToEnumx(response_descriptor);
+	Responsex(responses, elements, nodes,  vertices, loads, materials,  parameters,response_descriptor_enum, process_units, weight_index);
+
+}
+
+void Responsex(IssmDouble* responses,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,int response_descriptor_enum,bool process_units,int weight_index){
+
+	switch (response_descriptor_enum){
 
 		#ifdef _HAVE_RESPONSES_
@@ -41,4 +51,7 @@
 		case ThicknessAbsMisfitEnum:     ThicknessAbsMisfitx(      responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
 		case ThicknessAbsGradientEnum:   ThicknessAbsGradientx(    responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
+		case ThicknessAlongGradientEnum:   ThicknessAlongGradientx(    responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
+		case ThicknessAcrossGradientEnum:   ThicknessAcrossGradientx(    responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
+		case TotalSmbEnum:					TotalSmbx(                responses, elements,nodes, vertices, loads, materials, parameters,process_units); break;
 		case RheologyBbarAbsGradientEnum:RheologyBbarAbsGradientx( responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
 		case DragCoefficientAbsGradientEnum:DragCoefficientAbsGradientx(responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
@@ -46,7 +59,7 @@
 		case VelEnum:ElementResponsex(responses, elements,nodes, vertices, loads, materials, parameters,VelEnum,process_units); break;
 		case FrictionCoefficientEnum:NodalValuex(responses, FrictionCoefficientEnum,elements,nodes, vertices, loads, materials, parameters,process_units); break;
-		default: _error2_("response descriptor \"" << response_descriptor << "\" not supported yet!"); break;
+		default: _error_("response descriptor \"" << EnumToStringx(response_descriptor_enum) << "\" not supported yet!"); break;
 		#else
-		default: _error2_("ISSM was not compiled with responses capabilities, exiting!");
+		default: _error_("ISSM was not compiled with responses capabilities, exiting!");
 		#endif
 	}
Index: issm/trunk/src/c/modules/Responsex/Responsex.h
===================================================================
--- issm/trunk/src/c/modules/Responsex/Responsex.h	(revision 12709)
+++ issm/trunk/src/c/modules/Responsex/Responsex.h	(revision 13395)
@@ -6,8 +6,9 @@
 #define _RESPONSESX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 void Responsex(IssmDouble* presponse,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,const char* response_descriptor,bool process_units,int weight_index);
+void Responsex(IssmDouble* presponse,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,int response_descriptor_enum,bool process_units,int weight_index);
 
 #endif  /* _RESPONSESXX_H */
Index: issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void RheologyBbarAbsGradientx( double* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units, int weight_index){
+void RheologyBbarAbsGradientx( IssmDouble* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units, int weight_index){
 
 	/*Intermediary*/
@@ -17,6 +17,6 @@
 
 	/*output: */
-	double J=0;
-	double J_sum;
+	IssmDouble J=0;
+	IssmDouble J_sum;
 
 	/*Compute Misfit: */
Index: issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h
===================================================================
--- issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h	(revision 12709)
+++ issm/trunk/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void RheologyBbarAbsGradientx( double* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units,int weight_index);
+void RheologyBbarAbsGradientx( IssmDouble* pJ, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units,int weight_index);
 
 #endif
Index: issm/trunk/src/c/modules/Scotchx/Scotchx.h
===================================================================
--- issm/trunk/src/c/modules/Scotchx/Scotchx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Scotchx/Scotchx.h	(revision 13395)
@@ -20,5 +20,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 #ifdef _HAVE_SCOTCH_ //only works if scotch library has been compiled in.
Index: issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp
===================================================================
--- issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 13395)
@@ -9,5 +9,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* vector){
+void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* vector){
 
 	int  num_controls;
@@ -28,7 +28,7 @@
 }
 
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector* vector){
+void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector<IssmDouble>* vector){
 	
-	double* serial_vector=NULL;
+	IssmDouble* serial_vector=NULL;
 
 	serial_vector=vector->ToMPISerial();
@@ -37,4 +37,4 @@
 
 	/*Free ressources:*/
-	xDelete<double>(serial_vector);
+	xDelete<IssmDouble>(serial_vector);
 }
Index: issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h
===================================================================
--- issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h	(revision 12709)
+++ issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h	(revision 13395)
@@ -5,10 +5,10 @@
 #define _SETCONTROLINPUTSXFROMVECTOR_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector* vector);
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,double* vector);
+void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector<IssmDouble>* vector);
+void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,IssmDouble* vector);
 
 #endif 
Index: issm/trunk/src/c/modules/Shp2Kmlx/Shp2Kmlx.cpp
===================================================================
--- issm/trunk/src/c/modules/Shp2Kmlx/Shp2Kmlx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Shp2Kmlx/Shp2Kmlx.cpp	(revision 13395)
@@ -75,5 +75,5 @@
 
 	hSHP = SHPOpen( filshp, "rb" );
-	if (!hSHP) _error2_("Error opening shp/shx files.");
+	if (!hSHP) _error_("Error opening shp/shx files.");
 
 /*  read header and print out file bounds  */
Index: issm/trunk/src/c/modules/Shp2Kmlx/Shp2Kmlx.h
===================================================================
--- issm/trunk/src/c/modules/Shp2Kmlx/Shp2Kmlx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Shp2Kmlx/Shp2Kmlx.h	(revision 13395)
@@ -19,5 +19,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/SmbGradientsx/SmbGradientsx.h
===================================================================
--- issm/trunk/src/c/modules/SmbGradientsx/SmbGradientsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/SmbGradientsx/SmbGradientsx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/SmearFunctionx/SmearFunctionx.h
===================================================================
--- issm/trunk/src/c/modules/SmearFunctionx/SmearFunctionx.h	(revision 12709)
+++ issm/trunk/src/c/modules/SmearFunctionx/SmearFunctionx.h	(revision 13395)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
